diff --git a/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java b/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
index 6f0b950e8..852753b7d 100644
--- a/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
@@ -64,7 +64,7 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
             world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
             if(!world.isClientSide)
             {
-                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null);
+                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
             }
             world.setBlockMetadataWithNotify(x, y, z, decayData);
             world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CACAO.id, tickDelay());
diff --git a/src/main/java/net/minecraft/core/block/CactusBlock.java b/src/main/java/net/minecraft/core/block/CactusBlock.java
index 2e091d5ea..3734e86a6 100644
--- a/src/main/java/net/minecraft/core/block/CactusBlock.java
+++ b/src/main/java/net/minecraft/core/block/CactusBlock.java
@@ -112,7 +112,7 @@ public class CactusBlock extends Block implements IBonemealable
     {
         if(!canBlockStay(world, x, y, z))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/CandleBlock.java b/src/main/java/net/minecraft/core/block/CandleBlock.java
index 4c5b09147..c748c1c70 100644
--- a/src/main/java/net/minecraft/core/block/CandleBlock.java
+++ b/src/main/java/net/minecraft/core/block/CandleBlock.java
@@ -55,7 +55,7 @@ public class CandleBlock extends Block
         boolean flag = !world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
         if(flag)
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/ChestBlock.java b/src/main/java/net/minecraft/core/block/ChestBlock.java
index cf33e6946..ed88a7ba5 100644
--- a/src/main/java/net/minecraft/core/block/ChestBlock.java
+++ b/src/main/java/net/minecraft/core/block/ChestBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.ChestBlockEntity;
 import net.minecraft.core.block.material.Material;
@@ -12,9 +13,10 @@ import net.minecraft.core.player.inventory.container.CompoundContainer;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.slf4j.Logger;
 
 public class ChestBlock extends EntityBlock {
-	
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public ChestBlock(String key, String namespaceId, int id, Material material) {
 		super(key, namespaceId, id, material);
 	}
@@ -192,7 +194,7 @@ public class ChestBlock extends EntityBlock {
 	public static void dropChestContent(World world, int x, int y, int z) {
 		ChestBlockEntity tileEntityChest = (ChestBlockEntity) world.getBlockEntity(x, y, z);
 		if(tileEntityChest == null) {
-			System.out.println("Can't drop chest items because tile entity is null at x: "+x+" y:"+y+" z: "+z);
+            LOGGER.warn("Can't drop chest items because tile entity is null at x:{}, y:{}, z:{}", x, y, z);
 			return;
 		}
 		
@@ -249,7 +251,7 @@ public class ChestBlock extends EntityBlock {
 		if(world.isClientSide) return true;
 		
 		checkIfOtherHalfExists(world, x, y, z);
-		player.displayGUIChest(getInventory(world, x, y, z));
+		player.displayContainerScreen(getInventory(world, x, y, z));
 		
 		return true;
 	}
@@ -333,14 +335,15 @@ public class ChestBlock extends EntityBlock {
 	}
 	
 	public static Direction getDirectionFromMeta(int meta) {
-		meta = meta & 3;
-		
-		if(meta == 0) return Direction.NORTH;
-		if(meta == 1) return Direction.EAST;
-		if(meta == 2) return Direction.SOUTH;
-		if(meta == 3) return Direction.WEST;
-		
-		return Direction.NONE;
+		meta = meta & 0b11;
+
+		switch (meta) {
+			case 0: return Direction.NORTH;
+			case 1: return Direction.EAST;
+			case 2: return Direction.SOUTH;
+			case 3: return Direction.WEST;
+			default: return Direction.NONE;
+		}
 	}
 	
 	public static Type getTypeFromMeta(int meta) {
diff --git a/src/main/java/net/minecraft/core/block/ChestBlockPainted.java b/src/main/java/net/minecraft/core/block/ChestBlockPainted.java
index 04c02daa6..c894114c2 100644
--- a/src/main/java/net/minecraft/core/block/ChestBlockPainted.java
+++ b/src/main/java/net/minecraft/core/block/ChestBlockPainted.java
@@ -2,8 +2,10 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 public class ChestBlockPainted extends ChestBlock {
@@ -11,6 +13,11 @@ public class ChestBlockPainted extends ChestBlock {
 	protected ChestBlockPainted(String key, String namespaceId, int id, Material material) {
 		super(key, namespaceId, id, material);
 	}
+	
+	@Override
+	public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+		return stack.getMetadata();
+	}
 
 	@Override
 	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
diff --git a/src/main/java/net/minecraft/core/block/DispenserBlock.java b/src/main/java/net/minecraft/core/block/DispenserBlock.java
index a6e680913..877949a84 100644
--- a/src/main/java/net/minecraft/core/block/DispenserBlock.java
+++ b/src/main/java/net/minecraft/core/block/DispenserBlock.java
@@ -86,7 +86,7 @@ public class DispenserBlock extends RotatableEntityBlock
         } else
         {
             DispenserBlockEntity tileentitydispenser = (DispenserBlockEntity)world.getBlockEntity(x, y, z);
-            player.displayGUIDispenser(tileentitydispenser);
+            player.displayDispenserScreen(tileentitydispenser);
             return true;
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/DoorBlock.java b/src/main/java/net/minecraft/core/block/DoorBlock.java
index 395f38b30..ad251043e 100644
--- a/src/main/java/net/minecraft/core/block/DoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/DoorBlock.java
@@ -15,8 +15,10 @@ import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.save.LevelData;
 import org.jetbrains.annotations.Nullable;
 
 // Referenced classes of package net.minecraft.src:
@@ -143,7 +145,7 @@ public class DoorBlock extends Block
         }
         world.setBlockMetadataWithNotify(x, y, z, l ^ 4);
         world.markBlocksDirty(x, y - 1, z, x, y, z);
-        world.playSoundEffect(player, 1003, x, y, z, 0);
+        world.playSoundEffect(player, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
         return true;
     }
 
@@ -202,7 +204,7 @@ public class DoorBlock extends Block
             }
             if(!world.canPlaceOnSurfaceOfBlock(x, y - 1, z))
             {
-                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
                 world.setBlockWithNotify(x, y, z, 0);
                 flag = true;
                 if(otherBlock instanceof DoorBlock)
diff --git a/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java b/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
index 2e71e6a92..4ff4c1864 100644
--- a/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
+++ b/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
@@ -122,7 +122,7 @@ public class FireflyLanternBlock extends Block{
     {
         if(!canBlockStay(world, x, y, z))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/FlagBlock.java b/src/main/java/net/minecraft/core/block/FlagBlock.java
index 42c29847b..d107d6e54 100644
--- a/src/main/java/net/minecraft/core/block/FlagBlock.java
+++ b/src/main/java/net/minecraft/core/block/FlagBlock.java
@@ -57,14 +57,14 @@ public class FlagBlock extends EntityBlock {
 	public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
 		if (!world.isClientSide) {
 			FlagBlockEntity flag = (FlagBlockEntity) world.getBlockEntity(x, y, z);
-			if (flag.owner != null && !flag.owner.isEmpty() && !player.username.equals(flag.owner)) {
+			if (flag.owner != null && !player.uuid.equals(flag.owner)) {
 				return false;
 			}
 			int heldItemId = player.getHeldItem() != null ? player.getHeldItem().itemID : 0;
 			if(heldItemId == Items.MAP.id || heldItemId == Items.FLAG.id) {
 				return false;
 			}
-			player.displayGUIEditFlag(flag);
+			player.displayFlagEditorScreen(flag);
 			return true;
 		}
 		return true;
diff --git a/src/main/java/net/minecraft/core/block/FlowerBlock.java b/src/main/java/net/minecraft/core/block/FlowerBlock.java
index c72f1999f..9dd508b68 100644
--- a/src/main/java/net/minecraft/core/block/FlowerBlock.java
+++ b/src/main/java/net/minecraft/core/block/FlowerBlock.java
@@ -81,7 +81,7 @@ public class FlowerBlock extends Block implements IBonemealable
     {
         if(!canBlockStay(world, i, j, k))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
             world.setBlockWithNotify(i, j, k, 0);
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java b/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
index 0eaf1dad1..218ba91ac 100644
--- a/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
@@ -49,7 +49,7 @@ public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBo
             world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
             if(!world.isClientSide)
             {
-                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null);
+                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
             }
             world.setBlockMetadataWithNotify(x, y, z, decayData);
             world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, tickDelay());
diff --git a/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java b/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java
index a1b1642c0..282ba2dab 100644
--- a/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java
+++ b/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java
@@ -108,7 +108,7 @@ public class FlowingFluidBlock extends FluidBlock
         	int meta = world.getBlockMetadata(x, y - 1, z);
         	if(id > 0)
             {
-                Block.blocksList[id].dropBlockWithCause(world, EnumDropCause.WORLD, x, y - 1, z, meta, null);
+                Block.blocksList[id].dropBlockWithCause(world, EnumDropCause.WORLD, x, y - 1, z, meta, null, null);
         	}
             if(localFlowDecay >= 8) {
                 world.setBlockAndMetadataWithNotify(x, y - 1, z, this.id, localFlowDecay);
@@ -159,7 +159,7 @@ public class FlowingFluidBlock extends FluidBlock
                     fizz(world, i, j, k);
                 } else
                 {
-                    Block.blocksList[i1].dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null);
+                    Block.blocksList[i1].dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
                 }
             }
             world.setBlockAndMetadataWithNotify(i, j, k, id, l);
diff --git a/src/main/java/net/minecraft/core/block/FurnaceBlock.java b/src/main/java/net/minecraft/core/block/FurnaceBlock.java
index 41a1327d2..69c2ce2bd 100644
--- a/src/main/java/net/minecraft/core/block/FurnaceBlock.java
+++ b/src/main/java/net/minecraft/core/block/FurnaceBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.FurnaceBlockEntity;
@@ -10,6 +11,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.slf4j.Logger;
 
 import java.util.Random;
 
@@ -21,7 +23,7 @@ import java.util.Random;
 
 public class FurnaceBlock extends RotatableEntityBlock
 {
-
+    private static final Logger LOGGER = LogUtils.getLogger();
 	public FurnaceBlock(String key, String namespaceId, int id, boolean flag)
     {
         super(key, namespaceId, id, Material.stone);
@@ -91,21 +93,21 @@ public class FurnaceBlock extends RotatableEntityBlock
     {
         if (!world.isClientSide) {
             FurnaceBlockEntity tileentityfurnace = (FurnaceBlockEntity) world.getBlockEntity(x, y, z);
-            player.displayGUIFurnace(tileentityfurnace);
+            player.displayFurnaceScreen(tileentityfurnace);
         }
         return true;
     }
 
 	public static void updateFurnaceBlockState(boolean lit, World world, int x, int y, int z) {
 		int meta = world.getBlockMetadata(x, y, z);
-		BlockEntity tileentity = world.getBlockEntity(x, y, z);
-		if(tileentity == null) {
+		BlockEntity blockEntity = world.getBlockEntity(x, y, z);
+		if(blockEntity == null) {
 			String msg = "Furnace is missing Tile Entity at x: "+x+" y: "+y+" z: "+z+", block will be removed!";
 			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
 				throw new RuntimeException(msg);
 			}
 			world.setBlockWithNotify(x, y, z, 0);
-			System.out.println(msg);
+            LOGGER.warn(msg);
 			return;
 		}
 		keepFurnaceInventory = true;
@@ -116,8 +118,8 @@ public class FurnaceBlock extends RotatableEntityBlock
 		}
 		keepFurnaceInventory = false;
 		world.setBlockMetadataWithNotify(x, y, z, meta);
-		tileentity.validate();
-		world.setBlockTileEntity(x, y, z, tileentity);
+		blockEntity.validate();
+		world.setBlockTileEntity(x, y, z, blockEntity);
 	}
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/LadderBlock.java b/src/main/java/net/minecraft/core/block/LadderBlock.java
index 5ee6eda1f..a9bd3529a 100644
--- a/src/main/java/net/minecraft/core/block/LadderBlock.java
+++ b/src/main/java/net/minecraft/core/block/LadderBlock.java
@@ -48,7 +48,7 @@ public class LadderBlock extends Block {
 	@Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
 		if(!canExistAt(world, x, y, z, world.getBlockMetadata(x, y, z))) {
-			dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, blockId, null);
+			dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, blockId, null, null);
 			world.setBlockWithNotify(x, y, z, 0);
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java b/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java
index 74473f4b3..3bf083560 100644
--- a/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java
+++ b/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java
@@ -76,7 +76,7 @@ public class LeavesLayerBlock extends BaseLayerBlock
     {
         if(!canPlaceBlockAt(world, i, j, k))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
             world.setBlockWithNotify(i, j, k, 0);
             return false;
         } else
diff --git a/src/main/java/net/minecraft/core/block/LeverBlock.java b/src/main/java/net/minecraft/core/block/LeverBlock.java
index 21af5a45b..7cc1b88b0 100644
--- a/src/main/java/net/minecraft/core/block/LeverBlock.java
+++ b/src/main/java/net/minecraft/core/block/LeverBlock.java
@@ -107,7 +107,7 @@ public class LeverBlock extends Block
         }
 
         if(rotation == -1) {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
         } else {
             world.setBlockMetadataWithNotify(x, y, z, rotation | (isPowered ? MASK_POWERED : 0));
@@ -147,7 +147,7 @@ public class LeverBlock extends Block
             }
             if(shouldBreak)
             {
-                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
                 world.setBlockWithNotify(x, y, z, 0);
             }
         }
@@ -157,7 +157,7 @@ public class LeverBlock extends Block
     {
         if(!canPlaceBlockAt(world, x, y, z))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
             return false;
         } else
diff --git a/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java b/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
index e2e09f731..139619975 100644
--- a/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
+++ b/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
@@ -28,7 +28,7 @@ public class MobSpawnerBlock extends EntityBlock
             return false;
         }
 
-        player.displayGUIMobSpawnerPicker(x, y, z);
+        player.displayMobPickerScreen(x, y, z);
         return true;
     }
 
diff --git a/src/main/java/net/minecraft/core/block/OverlayPebblesBlock.java b/src/main/java/net/minecraft/core/block/OverlayPebblesBlock.java
index d6536bcc1..9f256a320 100644
--- a/src/main/java/net/minecraft/core/block/OverlayPebblesBlock.java
+++ b/src/main/java/net/minecraft/core/block/OverlayPebblesBlock.java
@@ -52,7 +52,7 @@ public class OverlayPebblesBlock extends Block
     {
         if (!canBlockStay(world,x, y, z))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java b/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java
index 2ae7966b8..eb86be43d 100644
--- a/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java
@@ -1,8 +1,10 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 public class PaintedFenceBlock extends FenceBlock
@@ -11,6 +13,11 @@ public class PaintedFenceBlock extends FenceBlock
 	{
 		super(key, namespaceId, id);
 	}
+	
+	@Override
+	public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+		return stack.getMetadata();
+	}
 
 	@Override
 	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
diff --git a/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java b/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
index 0743413f9..625aca883 100644
--- a/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
@@ -1,8 +1,10 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 public class PaintedFenceGateBlock extends FenceGateBlock
@@ -11,6 +13,11 @@ public class PaintedFenceGateBlock extends FenceGateBlock
 	{
 		super(key, namespaceId, id);
 	}
+	
+	@Override
+	public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+		return stack.getMetadata();
+	}
 
 	@Override
 	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
diff --git a/src/main/java/net/minecraft/core/block/PressurePlateBlock.java b/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
index 69f08f4e4..8331bf503 100644
--- a/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
+++ b/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
@@ -62,7 +62,7 @@ public class PressurePlateBlock extends Block
         boolean flag = !canPlaceBlockAt(world, x, y, z);
         if(flag)
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/RailBlock.java b/src/main/java/net/minecraft/core/block/RailBlock.java
index 8a5495621..a05f43701 100644
--- a/src/main/java/net/minecraft/core/block/RailBlock.java
+++ b/src/main/java/net/minecraft/core/block/RailBlock.java
@@ -94,7 +94,7 @@ public class RailBlock extends Block {
         RailDirection railDirection = getRailDirection(world, x, y, z);
 
         if(!isValidState(world, x, y, z)) {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
             return;
         }
diff --git a/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java b/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java
index 7ea6f59ae..c127c1d9c 100644
--- a/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java
+++ b/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java
@@ -307,7 +307,7 @@ public class RedstoneWireBlock extends Block
         int meta = world.getBlockMetadata(x, y, z);
         boolean flag = canPlaceBlockAt(world, x, y, z);
         if(!flag) {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
             world.setBlockWithNotify(x, y, z, 0);
         } else {
             updateAndPropagateCurrentStrength(world, x, y, z);
diff --git a/src/main/java/net/minecraft/core/block/RepeaterBlock.java b/src/main/java/net/minecraft/core/block/RepeaterBlock.java
index 00d477bd3..680360b39 100644
--- a/src/main/java/net/minecraft/core/block/RepeaterBlock.java
+++ b/src/main/java/net/minecraft/core/block/RepeaterBlock.java
@@ -101,7 +101,7 @@ public class RepeaterBlock extends Block
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
         if(!canBlockStay(world, x, y, z)) {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
             return;
         }
diff --git a/src/main/java/net/minecraft/core/block/RopeBlock.java b/src/main/java/net/minecraft/core/block/RopeBlock.java
index abbefe753..0fe24747c 100644
--- a/src/main/java/net/minecraft/core/block/RopeBlock.java
+++ b/src/main/java/net/minecraft/core/block/RopeBlock.java
@@ -3,9 +3,10 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ToolShearsItem;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
@@ -64,11 +65,12 @@ public class RopeBlock
 
         setBlockBounds(minX, minY, minZ, maxX, maxY, maxZ);
     }
+    
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         ItemStack heldItem = player.getHeldItem();
-        if (heldItem != null && heldItem.getItem() instanceof ToolShearsItem){
+        if (heldItem != null && heldItem.getItem() instanceof ToolShearsItem) {
             int meta = world.getBlockMetadata(x, y, z);
             int forceRope = (~meta) & 0b1000_0000;
             world.setBlockMetadataWithNotify(x, y, z, forceRope | (meta & 0b0111_1111));
@@ -78,8 +80,65 @@ public class RopeBlock
             }
             return true;
         }
+        
+        if(heldItem == null) {
+        	pickUpRope(world, x, y, z, player);
+        	return true;
+        }
+        
         return false;
     }
+    
+    public void pickUpRope(World world, int x, int y, int z, Player player) {
+    	if(world.isClientSide || world.getBlock(x, y, z) != this) {
+    		return;
+    	}
+    	
+    	final int highestRope = y;
+    	// Find the position of the lowest rope
+    	while(y > 0) {
+    		Block block = world.getBlock(x, y - 1, z);
+    		if(block != this) {
+    			break;
+    		}
+    		y--;
+    	}
+    	final int lowestRope = y;
+    	
+    	// Determine how many ropes fit into the players inventory
+    	int freeSpace = 0;
+    	for(int i=0; i < player.inventory.mainInventory.length; i++) {
+    		ItemStack stack = player.inventory.mainInventory[i];
+    		if(stack == null) {
+    			freeSpace += Items.ROPE.getItemStackLimit();
+    			continue;
+    		}
+    		if(stack.getItem() == Items.ROPE) {
+    			freeSpace += Items.ROPE.getItemStackLimit() - stack.stackSize;	
+    		}
+    	}
+    	freeSpace = Math.min(freeSpace, 1);
+    	
+    	int ropesCollected = 0;
+    	for(y = lowestRope; y <= highestRope; y++) {
+    		if(ropesCollected >= freeSpace) {
+    			break;
+    		}
+    		world.setBlockWithNotify(x, y, z, 0);
+    		ropesCollected++;
+    	}
+    	
+    	if(player.getGamemode().consumeBlocks()) {
+    		ItemStack stack = new ItemStack(Items.ROPE, ropesCollected);
+    		player.inventory.insertItem(stack, true);
+    		if(stack.stackSize > 0) {
+        		// this shouldnt happen
+        		player.dropPlayerItem(stack);
+        	}	
+    	}
+    	
+    	world.playBlockSoundEffect(player, x + 0.5, highestRope + 0.5, z + 0.5, this, EnumBlockSoundEffectType.PLACE);
+    }
 
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity) {
diff --git a/src/main/java/net/minecraft/core/block/SignBlock.java b/src/main/java/net/minecraft/core/block/SignBlock.java
index 2557be6f6..e3e5ca388 100644
--- a/src/main/java/net/minecraft/core/block/SignBlock.java
+++ b/src/main/java/net/minecraft/core/block/SignBlock.java
@@ -145,7 +145,7 @@ public class SignBlock extends EntityBlock
         }
         if(flag)
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
         }
         super.onNeighborBlockChange(world, x, y, z, blockId);
@@ -169,7 +169,7 @@ public class SignBlock extends EntityBlock
             } else if (player.getHeldItem() != null && player.getHeldItem().itemID == Items.DYE.id) {
                 return false;
             } else if (signEntity.isEditableBy(player)) {
-                player.displayGUIEditSign(signEntity);
+                player.displaySignEditorScreen(signEntity);
                 return true;
             }
         }
diff --git a/src/main/java/net/minecraft/core/block/SnowBlock.java b/src/main/java/net/minecraft/core/block/SnowBlock.java
index 9eaca196e..5ce60b89c 100644
--- a/src/main/java/net/minecraft/core/block/SnowBlock.java
+++ b/src/main/java/net/minecraft/core/block/SnowBlock.java
@@ -33,7 +33,7 @@ public class SnowBlock extends Block
     {
         if(world.getSavedLightValue(LightLayer.Block, x, y, z) > 11)
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
         }
     }
